class SearchController < ApplicationController
  include SearchEngine::OrientdbLucene

  def index
    @types = learning_object_repository.get_types
  end

  def fetch
    objectsFound = []

    params[:subject]= params[:subject].split(', ')
    params[:type] = params[:type].split(', ')
    params[:school_year] = params[:school_year].split(', ')
    params[:year] = params[:year].split('-').take(2)
    page=1
    if (params[:page])
      page = params[:page].to_i
    end

    @pagination_limit=10

    unless params[:query].blank?
      objectsFound = search params
      @numFound = objectsFound.length

      # case params[:order]
      #   items = objectsFound.collect{ |x| Ranking::Item.new(x.name,x.views,0,x.likes,x)  } #puts each object in an item
      #
      #   rater = Ranking::Rater.new(
      #       Ranking::Strategies::BasicRater.new(
      #           #define ordering weights
      #           positionWeight = 1000,
      #           useWeight = 1,
      #           likeWeight = 100
      #       )
      #   )
      #
      #   a = rater.orderByRate(items) # Returns ordered array of items
      #   objectsFound = a.collect{ |x|  x.info  } #get only the info fields(objects)
      # end
    end

    @result = Kaminari.paginate_array(objectsFound).page(page).per(@pagination_limit)
    @last_page = (@result.num_pages <= page) ? true : false;

    # build objects from one page only
    @objects = LearningObjectBuilder.build(@result)

    render partial: 'search/fetch'
  end

  def autocomplete
    begin
      auto = AutocompleteService.new
      query = params["q"] || ""
      json_data = auto.query(query)
      render text: json_data
    rescue
      render text: "[]"
    end
  end

end
